<?php
/* 
 * Inserta reposición
 */
$pag = "../asignacion_crear.php";
$ruta = "../";
require_once "../class/c_login.php";
require_once "../class/mailer.php";

define("COORDINADOR", 9);
define("ENVIO_CORREOS", true);

// check if the session is started
if (!isset($_SESSION['user']))
    die('No se ha iniciado sesión');

$user = unserialize($_SESSION['user']);
//$user->access();

$duracion_id = filter_input(INPUT_POST, "duracion", FILTER_SANITIZE_NUMBER_INT);//Id reposicion
$fecha = trim(htmlspecialchars($_POST["fecha_inicial"], ENT_QUOTES, "UTF-8"));//limpia texto
$hora_ini = filter_input(INPUT_POST, "hora_ini", FILTER_SANITIZE_NUMBER_INT);//limpia texto
$min_ini = filter_input(INPUT_POST, "min_ini", FILTER_SANITIZE_NUMBER_INT);//limpia texto
$alumnos = filter_input(INPUT_POST, "alumnos", FILTER_SANITIZE_NUMBER_INT);//limpia texto
$aula = filter_input(INPUT_POST, "aula", FILTER_SANITIZE_NUMBER_INT);//1 regular , 2 sala computo, 3 otro facultad
if(isset($_POST["salon"]) && $_POST["salon"] != "")
    $salon = filter_input(INPUT_POST, "salon", FILTER_SANITIZE_NUMBER_INT);//limpia texto

if(empty($_POST["prof"]))
    $prof = $user["id"];
else
    $prof = filter_input(INPUT_POST, "prof", FILTER_SANITIZE_NUMBER_INT);//limpia texto
//if(isset($_POST["salon"]) && $_POST["salon"] != "")
//$salon = trim(filter_input(INPUT_POST, "salon", FILTER_SANITIZE_STRING,array('flags' => FILTER_FLAG_STRIP_LOW)));//limpia texto
$comentario = trim(htmlspecialchars($_POST["comentario"], ENT_QUOTES, "UTF-8"));//limpia texto

$aula_rs = $db->querySingle("select tipoaula_nombre, tipoaula_supervisor from tipoaula where tipoaula_id = :id", [":id"=>$aula]);


$duracion_rs = $db->querySingle("select * from duracion where duracion_id = :id", [":id"=>$duracion_id]);
$duracion_tiempo = $duracion_rs["duracion_interval"];

//-- Obtiene datos de horario regular de clase

$hora = $hora_ini.":".$min_ini.":00";
$fecha_new =  DateTime::createFromFormat('d/m/Y', $fecha)->format('Y-m-d')." ".$hora;
$fecha_fin_new = date("Y-m-d", strtotime($fecha_new))." ".$duracion_tiempo;
$dia_new = date('w', strtotime($fecha_new));

//Datos de dependencia de usuario
$fac_rs = $db->querySingle("SELECT facultad_nombre, clave_dependencia from facultad where facultad_id = :id_fac",[':id_fac' => $user->facultad["facultad_id"]] );

$salon_desc = "Pendiente";
if(!empty($salon)){
    $salon_rs = $db->querySingle('SELECT s.salon_id, s.salon_array FROM salon_view s where s.salon_id  = :id_salon',
            [':id_salon' => $salon]
        );
    if($salon_rs["salon_id"] == "" || $salon_rs["salon_id"] == NULL){
        $salon_desc = "Pendiente";
    }else{
        $salon_json = json_decode($salon_rs["salon_array"], true);
        if($salon_json[0]== "UNIVERSIDAD LA SALLE"){
            unset($salon_json[0]);
        }
        $salon_desc = join(" / ",$salon_json);
    }
}

//Obtiene correos
$correos_rs = $db->query('SELECT coor.usuario_correo as coordinador_correo 
        from reposicion_solicitud rs 
        inner join profesor p on rs.profesor_id =p.profesor_id 
        inner join usuario u on u.usuario_id = rs.usuario_id
        inner join horario_view hv on hv.horario_id  = rs.horario_id 
        inner join usuario coor on hv.facultad_id = coor.facultad_id and coor.rol_id = :rol_coord
        where hv.facultad_id = :id_fac',
            [':rol_coord' => COORDINADOR, ':id_fac' => $user->facultad["facultad_id"]]
        );
$coord_correos=[];
foreach($correos_rs as $correo){
    if( count($coord_correos)==0 && $correo["coordinador_correo"]!=""){
        if(!isset($coord_correos["correo"]) || !in_array($correo["coordinador_correo"], $coord_correos["correo"])){
            array_push($coord_correos, $correo["coordinador_correo"]);
        }
    }
}

$correosSup_rs = $db->querySingle("SELECT DISTINCT sup.usuario_correo as coordinador_correo
    FROM horario_supervisor hs
    inner join usuario sup on sup.usuario_id =hs.usuario_id 
    where :id_fac = ANY(hs.facultad_id_array)
        and sup.usuario_correo is not null and sup.usuario_correo != ''",
    [':id_fac' => $user->facultad["facultad_id"]] );


// Valida que grupo no tenga clases
/*$result = validaConflictoHoras($pdo, $gpo, $dia_new, $hora, $materia, "-", $fecha_new, $fecha_fin_new, $duracion);
if($result != ""){//error
    //echo $result;
    header("Location:".$pag."?error=7");
    exit();
}
*/
//Valida que profesor no este en 2 reposiciones al mismo tiempo en la fecha nueva

$traslape = $db->querySingle('SELECT * from traslape_profesor_reposicion(:prof, :fecha, :hora, :dur)',
    [':prof' => $prof, ':fecha'=>DateTime::createFromFormat('d/m/Y', $fecha)->format('Y-m-d'), ':hora'=>$hora, ':dur'=>$duracion_tiempo]
)["traslape_profesor_reposicion"];
if($traslape){
    //print_r($_POST);
    //echo "SELECT * from traslape_profesor_reposicion($prof,'".DateTime::createFromFormat('d/m/Y', $fecha)->format('Y-m-d')."' , '$hora', $duracion)";
    
    header("Location:".$pag."?error=9");
    exit();
}

try{
    $edo = 1;
    if(!$user->jefe_carrera)
        $edo = 2;

    //echo "SELECT * from fi_asignacion_solicitud( $fecha_new,  $hora, $prof, $edo, $comentario, $alumnos, $aula, $duracion_tiempo, ".$user->user["id"].")"; exit();
    $db->query('SELECT * from fi_asignacion_solicitud(:f_nueva, :hora_nueva, :prof, :edo, :desc, :alumnos, :aula, :duracion, :usr)',
        [':f_nueva' => $fecha_new, ':hora_nueva' => $hora, 
        ':prof' => $prof, ':edo'=>$edo, ':desc' => $comentario, ':alumnos' => $alumnos, ':aula' => $aula, ':duracion' => $duracion_tiempo, ':usr'=>$user->user["id"]
        ]
    );
}catch(Exception $e){
    echo $e->getMessage();
    //header("Location: ".$pag."?error=1");
    exit();
}

$asunto = "";
$texto = "";
$to = "";
switch($edo){
    case 1://Correo a coordinador
        if( count($coord_correos) > 0 ){
            $to = join(",", $coord_correos);
        }
        $asunto = "Solicitud de salon nueva";
        $texto = "<p>Se creó una solicitud de asignación de salón nueva.</p>";
        $texto .= "<p><b>Se solicita un espacio de tipo ".mb_strtoupper($aula_rs["tipoaula_nombre"])."</b> para el día <b>".$fecha." a las ".$hora." hrs. </b>";
        $texto .= "<p>Ingresa al <a href='https://paad.lci.ulsa.mx'>sistema PAAD</a> para autorizarla.</p>";
    break;
    case 2://Correo a supervisor
        $asunto = "Solicitud de salon nueva - ".$fac_rs["clave_dependencia"]." ".$fac_rs["facultad_nombre"];
        //crear plantilla
        $texto = "<p>Se creó una solicitud de asignación de salón nueva para: <b>".$fac_rs["clave_dependencia"]." ".$fac_rs["facultad_nombre"]."</b>.</p>";
        $texto .= "<p>Para el día <b>".$fecha." a las ".$hora." hrs. </b>";
        if(!$aula_rs["tipoaula_supervisor"]){
            $texto .= " en el salón: <b>".$salon_desc."</b></p>";
        }else{
            $texto .= " en un salón de tipo: <b>".mb_strtoupper($aula_rs["tipoaula_nombre"])."</b></p>";
        }
        $texto .= "<p>Ingresa al <a href='https://paad.lci.ulsa.mx'>sistema PAAD</a> para autorizarla.</p>";
        $to = join(",", $correosSup_rs);
    break;
}

/*
$log = new LogActividad();
$desc_log = "Inserta reposición nueva ID[".$rs["fi_reposicion"]."] Fechas[".$fecha_falta.">".$fecha_new."] Periodo[".$_SESSION["periodo_id"]."] Materia[".$materia."] Profesor[".$prof."] Salon[".$salon."] Horario[".$hor."] Alumnos[".$alumnos."]";
$log->appendLog($_SESSION["usuario_id"], $_SESSION["usuario_nombre"]." ".$_SESSION["usuario_apellidos"], $desc_log);*/



if($to!= "" && ENVIO_CORREOS){
        //crear plantilla
    $texto = '<body >
            <img src="https://paad.lci.ulsa.mx/imagenes/logo_lasalle.png" alt="La Salle" style="margin-bottom:60px">
            '.$texto.'
        </body>';
    
    require_once('../include/phpmailer/PHPMailerAutoload.php');
    if($_ENV['DB_NAME'] == "paad_pruebas"){
        $asunto = "PRUEBAS-".$asunto;
        Mailer::enviarCorreo("alejandro.lara@lasalle.mx", $asunto, $texto, true);
    }else{
        Mailer::enviarCorreo($to, $asunto, $texto, true);
    }
}

header("Location: ".$pag."?ok=0");
?>
